# Class ProxyModule

#### Hierarchy

- BaseEmitter<ProxyModuleParams, ModuleEventData>
  - ProxyModule

#### Implements

- Module<ModuleParams, ModuleEventData>

- Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:13

#####
Index

### Constructors

constructor

### Properties

eventData
params
upResolver
defaultLogger?

### Accessors

address
bridge
config
downResolver
logger
queries

### Methods

clearListeners
emit
emitSerial
listenerCount
off
offAny
on
onAny
once
query
queryable
resolve

## Constructors

### constructor

- new ProxyModule(params): ProxyModule

- #### Parameters

  - ##### params: ProxyModuleParams

  #### Returns ProxyModule

  Overrides BaseEmitter.constructor

  - Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:15

## Properties

### eventData

eventData: ModuleEventData

Implementation of Module.eventData

Inherited from BaseEmitter.eventData

- Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:4

### `Readonly` params

params: ProxyModuleParams

Implementation of Module.params

Inherited from BaseEmitter.params

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:20

### `Readonly` upResolver

upResolver: CompositeModuleResolver

Implementation of Module.upResolver

- Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:14

### `Static` `Optional` defaultLogger

defaultLogger?: Logger

Inherited from BaseEmitter.defaultLogger

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:21

## Accessors

### address

- get address(): string

- #### Returns string

  Implementation of Module.address

  - Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:16

### bridge

- get bridge(): BridgeModule<BridgeParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.bridge.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<{
  discoverCache?: true | CacheConfig;
  schema: "network.xyo.bridge.config";
  }, "schema">, "schema"> & {
  schema: string;
  }, "schema">>, ModuleEventData, Module<ModuleParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ModuleEventData>>

- #### Returns BridgeModule<BridgeParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.bridge.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<{
  discoverCache?: true | CacheConfig;
  schema: "network.xyo.bridge.config";
  }, "schema">, "schema"> & {
  schema: string;
  }, "schema">>, ModuleEventData, Module<ModuleParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ModuleEventData>>

  - Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:17

### config

- get config(): SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">

- #### Returns SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">

  Implementation of Module.config

  - Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:77

### downResolver

- get downResolver(): ModuleResolver

- #### Returns ModuleResolver

  Implementation of Module.downResolver

  - Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:78

### `Protected` logger

- get logger(): Logger | Console

- #### Returns Logger | Console

  Inherited from BaseEmitter.logger

  - Defined in protocol/packages/core/dist/types/lib/Base.d.ts:23

### queries

- get queries(): string[]

- #### Returns string[]

  Implementation of Module.queries

  - Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:79

## Methods

### clearListeners

- clearListeners(eventNames): void

- #### Parameters

  - ##### eventNames: keyof ModuleEventData | (keyof ModuleEventData)[]

  #### Returns void

  Implementation of Module.clearListeners

  Inherited from BaseEmitter.clearListeners

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:7

### emit

- emit<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData = keyof ModuleEventData

  - #### TEventArgs extends EventArgs = ModuleEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Implementation of Module.emit

  Inherited from BaseEmitter.emit

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:8

### emitSerial

- emitSerial<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData = keyof ModuleEventData

  - #### TEventArgs extends EventArgs = ModuleEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Implementation of Module.emitSerial

  Inherited from BaseEmitter.emitSerial

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:9

### listenerCount

- listenerCount(eventNames): number

- #### Parameters

  - ##### eventNames: keyof ModuleEventData | (keyof ModuleEventData)[]

  #### Returns number

  Implementation of Module.listenerCount

  Inherited from BaseEmitter.listenerCount

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:10

### off

- off<TEventName>(eventNames, listener): void

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<ModuleEventData[TEventName]>

  #### Returns void

  Implementation of Module.off

  Inherited from BaseEmitter.off

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:11

### offAny

- offAny(listener): void

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns void

  Implementation of Module.offAny

  Inherited from BaseEmitter.offAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:12

### on

- on<TEventName>(eventNames, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<ModuleEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Implementation of Module.on

  Inherited from BaseEmitter.on

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:13

### onAny

- onAny(listener): (() => void)

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Implementation of Module.onAny

  Inherited from BaseEmitter.onAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:14

### once

- once<TEventName>(eventName, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData

  #### Parameters

  - ##### eventName: TEventName

  - ##### listener: EventListener<ModuleEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Implementation of Module.once

  Inherited from BaseEmitter.once

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:15

### query

- query<T>(query, payloads?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Implementation of Module.query

  - Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:80

### queryable

- queryable(query, payloads?, queryConfig?): Promise<boolean>

- #### Parameters

  - ##### query: SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Returns Promise<boolean>

  Implementation of Module.queryable

  - Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:81

### resolve

- resolve(filter?): Promise<Module<ModuleParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ModuleEventData>[]>

- #### Parameters

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<Module<ModuleParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ModuleEventData>[]>

  - Defined in modules/packages/bridge/packages/module-resolver/dist/types/ProxyModule.d.ts:82

Generated using TypeDoc